
Ruby - Bug #16510

irb crashes when hitting 'Home' or 'End' keys

01/15/2020 03:22 PM - packerbacker89 (Josh Johnson)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 2.7.0 Backport: 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7:

UNKNOWN

Description

There were similar bugs opened in the past few months, but they all appear to be closed.

System: Ruby 2.7.0, reline 0.1.2, irb 1.2.1

Open irb and hit the 'Home' or 'End' key on the keyboard. This should go to the beginning / end of the line. Instead, the console

crashes and the following traceback is provided:

 35: from /x/ruby-2.7.0/bin/irb:23:in `<main>'

 34: from /x/ruby-2.7.0/bin/irb:23:in `load'

 33: from /x/ruby-2.7.0/lib/ruby/gems/2.7.0/gems/irb-1.2.1/exe/irb:11:in `<top (required)>'

 32: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:398:in `start'

 31: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:469:in `run'

 30: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:469:in `catch'

 29: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:470:in `block in run'

 28: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:535:in `eval_input'

 27: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb/ruby-lex.rb:134:in `each_top_level_statement'

 26: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb/ruby-lex.rb:134:in `catch'

 25: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb/ruby-lex.rb:135:in `block in each_top_level_statement'

 24: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb/ruby-lex.rb:135:in `loop'

 23: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb/ruby-lex.rb:138:in `block (2 levels) in each_top_level_

statement'

 22: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb/ruby-lex.rb:166:in `lex'

 21: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:516:in `block in eval_input'

 20: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:693:in `signal_status'

 19: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb.rb:517:in `block (2 levels) in eval_input'

 18: from /x/ruby-2.7.0/lib/ruby/2.7.0/irb/input-method.rb:258:in `gets'

 17: from /x/ruby-2.7.0/lib/ruby/2.7.0/forwardable.rb:235:in `readmultiline'

 16: from /x/ruby-2.7.0/lib/ruby/2.7.0/forwardable.rb:235:in `readmultiline'

 15: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:170:in `readmultiline'

 14: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:232:in `inner_readline'

 13: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:232:in `loop'

 12: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:233:in `block in inner_readline'

 11: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:262:in `read_io'

 10: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:262:in `loop'

  9: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:286:in `block in read_io'

  8: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:234:in `block (2 levels) in inner_readline

'

  7: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:234:in `each'

  6: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline.rb:235:in `block (3 levels) in inner_readline

'

  5: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline/line_editor.rb:829:in `input_key'

  4: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline/line_editor.rb:787:in `normal_char'

  3: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline/line_editor.rb:758:in `process_key'

  2: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline/line_editor.rb:1109:in `ed_insert'

  1: from /x/ruby-2.7.0/gems/reline-0.1.2/lib/reline/unicode.rb:70:in `get_mbchar_width'

/x/ruby-2.7.0/gems/reline-0.1.2/lib/reline/unicode.rb:70:in `encode': "\\xCF" from ASCII-8BIT to U

TF-8 (Encoding::UndefinedConversionError)

 In addition, hitting the 'Insert', 'Page Up', and 'Page Down' keys result in odd characters shown in the console (such as "^[[2~"). This

is only a minor issue compared to the console crash.
Associated revisions

Revision 5d124a3b68982e779946804b5b9578c403c6bdf2 - 01/29/2020 06:11 AM - aycabta (aycabta .)

[ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

https://github.com/ruby/reline/commit/788f0df845

Revision 5d124a3b68982e779946804b5b9578c403c6bdf2 - 01/29/2020 06:11 AM - aycabta (aycabta .)

[ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

https://github.com/ruby/reline/commit/788f0df845

Revision 5d124a3b - 01/29/2020 06:11 AM - aycabta (aycabta .)

[ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

https://github.com/ruby/reline/commit/788f0df845

Revision 0057fe4063b57b445d6ffc893e442f362e3a19e0 - 03/30/2020 10:09 AM - aycabta (aycabta .)

Ruby 2.7 backport about IRB (#2990)

[ruby/reline] Sort completion list

Legacy mode:

$ irb --legacy

irb(main):001:0> l[TAB][TAB]

lambda           load             local_variables  loop

 Before this patch:

$ irb

irb(main):001:0> l[TAB][TAB]

local_variables

loop

lambda

load

 After this patch:

$ irb

irb(main):001:0> l[TAB][TAB]

lambda

load

local_variables

loop

 https://github.com/ruby/reline/commit/6074069c7d

Drop an invalid char as UTF-8

Add test_completion_with_indent_and_completer_quote_characters

This is for 8a705245e55575d4d310a2e956b89a36a5931971.

[ruby/irb] Add tests for RubyLex

The set_auto_indent method calculates the correct number of spaces for

indenting a line. We think there might be a few bugs in this method so

we are testing the current functionality to make sure nothing breaks

when we address those bugs.

Example test failure:

  1) Failure:

TestIRB::TestRubyLex#test_auto_indent [/Users/Ben/Projects/irb/test/irb/test_ruby_lex.rb:75]:

Calculated the wrong number of spaces for:

 def each_top_level_statement

  initialize_input

  catch(:TERM_INPUT) do

    loop do
      begin

        prompt

        unless l = lex

          throw :TERM_INPUT if @line == ''

        else

.

<10> expected but was

<12>.

 https://github.com/ruby/irb/commit/752d5597ab

[ruby/reline] Degenerate the terminal size to [$LINES, $COLUMNS] if it is unknown

This is a workaround for https://github.com/ruby/irb/issues/50

https://github.com/ruby/reline/commit/5725677d1a

[ruby/irb] Fix newline depth with multiple braces

This commit fixes the check_newline_depth_difference method to multiple

open braces on one line into account. Before this change we were

subtracting from the depth in check_newline_depth_difference on

every open brace. This is the right thing to do if the opening and

closing brace are on the same line. For example in a method definition we

have an opening and closing parentheses we want to add 1 to our depth,

and then remove it.

def foo()

end

 However this isn't the correct behavior when the brace spans multiple

lines. If a brace spans multiple lines we don't want to subtract from

check_newline_depth_difference and we want to treat the braces the same

way as we do end and allow check_corresponding_token_depth to pop the

correct depth.

Example of bad behavior:

def foo()

  [

  ]

puts 'bar'

end

 Example of desired behavior:

def foo()

  [

  ]

  puts 'bar'

end

 https://github.com/ruby/irb/commit/7dc8af01e0

text/readline/test_readline.rb - fix skip on Reline (#2743)

TestRelineAsReadline#test_input_metachar passes on MinGW

Add "require 'openstruct'" what is forgotten

[ruby/irb] Fix lib name of OpenStruct

https://github.com/ruby/irb/commit/1f3a84ab6b

Add load path and require for ruby/ruby

Rescue EOFError

If C-d is pressed before IRB is ready, IRB crashes because EOFError occurs.

Complete indented and quoted string correctly

def foo

06/25/2025 3/28

https://github.com/ruby/irb/commit/752d5597ab
https://github.com/ruby/irb/issues/50
https://github.com/ruby/reline/commit/5725677d1a
https://github.com/ruby/irb/commit/7dc8af01e0
https://github.com/ruby/irb/commit/1f3a84ab6b


''.upca[TAB]

This will be completed to be:

def foo

''.upcase

The indent was gone. This commit fixes the bug.

[ruby/irb] Fix crashing when multiple open braces per line

https://github.com/ruby/irb/issues/55

If we had put multiple open braces on a line the with no closing brace

spaces_of_nest array keeps getting '0' added to it. This means that when

we pop off of this array we are saying that we should be in position zero

for the next line. This is an issue because we don't always want to be

in position 0 after a closing brace.

Example:

[[[

]

]

]

 In the above example the 'spaces_of_nest' array looks like this after

the first line is entered: [0,0,0]. We really want to be indented 4

spaces for the 1st closing brace 2 for the 2nd and 0 for the 3rd. i.e.

we want it to be: [0,2,4].

We also saw this issue with a heredoc inside of an array.

[<<FOO]

hello

FOO

 https://github.com/ruby/irb/commit/80c69c8272

Support history-size in .inputrc correctly

Introduce an abstracted structure about the encoding of Reline

The command prompt on Windows always uses Unicode to take input and print

output but most Reline implementation depends on Encoding.default_external.

This commit introduces an abstracted structure about the encoding of Reline.

Remove an unused setting variable

Use Reline.encoding_system_needs if exists

Add tests for vi_insert and vi_add

Implement vi_insert_at_bol and vi_add_at_eol

[ruby/reline] Implement vi_to_next_char

https://github.com/ruby/reline/commit/066ecb0a21

[ruby/reline] Implement vi_prev_char and vi_to_prev_char

https://github.com/ruby/reline/commit/0ad3ee63fa

[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there

https://github.com/ruby/readline-ext/commit/4d44c12832

Stop using minitest dependent methods

Skip a test that uses assert_ruby_status if it doesn't exist

Use omit instead of skip
Check DONT_RUN_RELINE_TEST envvar

[ruby/irb] Add newline_before_multiline_output

https://github.com/ruby/irb/commit/9eb1801a66

[ruby/irb] Fix compatibility with rails before 5.2

Rails before 5.2 added Array#append as an alias to Array#<< ,

so that it expects only one argument.

However ruby-2.5 added Array#append as an alias to Array#push

which takes any number of arguments.

If irb completion is used in rails c (for example "IO.")

it fails with:

irb/completion.rb:206:in `<<': wrong number of arguments (given 3, expected 1) (ArgumentError)

Using Array#push instead of Array#append fixes compatibility.

https://github.com/ruby/irb/commit/5b7bbf9c34

Reline: Use a more robust detection of MinTTY

The previous detection per get_screen_size fails when stdout is passed

to a pipe. That is the case when running ruby tests in parallel ("-j" switch).

In this case Reline believes that it's running on MinTTY and the tests

are running with ANSI IOGate instead of the Windows adapter on MINGW.

So parallel test results were different to that of a single process.

This commit fixes these differencies.

The code is taken from git sources and translated to ruby.

NtQueryObject() is replaced by GetFileInformationByHandleEx(), because

NtQueryObject() is undocumented and is more difficult to use:

https://github.com/git-for-windows/git/blob/c5a03b1e29c69f3f06c8fabd92493edb73469176/compat/winansi.c#L558

Reline: Fix changed test results due to change to UTF-8 on Windows

In commit f8ea2860b0cac1aec79978e6c44168802958e8af the Reline encoding

for native windows console was changed to hardcoded UTF-8.

This caused failures in reline and readline tests, but they were hidden,

because parallel ruby tests incorrectly used Reline::ANSI as IOGate.

Tests failures were raised in single process mode, but not with -j switch.

This patch corrects encodings on native Windows console.

[ruby/irb] [ruby/irb] Rewrite an expression to detect multiline

https://github.com/ruby/irb/commit/ed5cf375a6

https://github.com/ruby/irb/commit/5b7bbf9c34

[ruby/reline] Implement vi_change_meta

https://github.com/ruby/reline/commit/8538e0e10f

Always refer to Reline::IOGate.encoding

Always use UTF-8 for Reline::GeneralIO on Windows

Use test_mode on Reline::History::Test for encoding

[ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

https://github.com/ruby/reline/commit/788f0df845

[ruby/irb] Add a new easter egg: dancing ruby

https://github.com/ruby/irb/commit/e37dc7e58e

[ruby/irb] Exclude useless files from RDoc

https://github.com/ruby/irb/commit/8f1ab2400c
[ruby/irb] Exclude useless files from RDoc

Fix inaccuracy in encoding tests

These tests assume

Encoding.find('locale') == Encoding.find('external')

and fail if they are distinct.

[ruby/reline] Fix Reline::Windows#scroll_down

I mistook Right and Bottom.

https://github.com/ruby/reline/commit/8be401c5f5

[ruby/reline] Bypass cursor down when a char is rendered at eol on Windows

A newline is automatically inserted if a character is rendered at eol on

Windows command prompt.

https://github.com/ruby/reline/commit/4bfea07e4a

[ruby/reline] Organize special keys escape sequences

https://github.com/ruby/reline/commit/41deb1a3d9

[ruby/readline-ext] Remove unnecessary -I$(top_srcdir) when it's an individual gem

https://github.com/ruby/readline-ext/commit/efaca4a5f4

[ruby/readline-ext] Check TestRelineAsReadline existance

https://github.com/ruby/readline-ext/commit/c0a6303168

[ruby/readline-ext] The ruby/assert.h is adopted by Ruby 2.7 or later

https://github.com/ruby/readline-ext/commit/106c31fc1b

Revert "[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there"

This reverts commit 425b2064d394639101854c83a061a0918b33b857.

This cherry-pick was a mistake.

[ruby/readline-ext] Use require check instead of DONT_RUN_RELINE_TEST env

https://github.com/ruby/readline-ext/commit/1df99d1481

[ruby/readline-ext] Add spec.extensions

https://github.com/ruby/readline-ext/commit/8c33abb13c

[ruby/readline-ext] Use rake/extensiokntask to build

https://github.com/ruby/readline-ext/commit/b0b5f709bd

Fix readline build dependency

[ruby/irb] Add test_complete_symbol

https://github.com/ruby/irb/commit/dbbf086c1f

[ruby/irb] Check doc namespace correctly

IRB::InputCompletor::PerfectMatchedProc crashes when doc not found because a

variable name was incorrect.

https://github.com/ruby/irb/commit/889fd4928f

[ruby/irb] Fix auto indent with closed brace

A closed brace in auto-indent shouldn't affect the next brace in the same line,

but it behaves like below:
p() {

}

It's a bug.

https://github.com/ruby/irb/commit/fbe59e344f

[ruby/irb] Use 0.step instead of (..0).each for Ruby 2.5

https://github.com/ruby/irb/commit/5d628ca40e

Revert "[ruby/irb] Add test_complete_symbol"

This reverts commit 3af3431c2c145134996e66f3d8d9ade8ad81bde0.

[ruby/irb] fix reserved words and completion for them

https://github.com/ruby/irb/commit/6184b227ad

Add test_complete_symbol

The previous version of the test method used a symbol, ":abcdefg" to complete

but longer symbols that can be completed are defined by other test methods of

other libs.

test/irb/test_completion.rb: suppress a warning: unused literal ignored

[ruby/reline] Use IO#write instead of IO#print

IO#print always adds a string of $\ automatically.

https://github.com/ruby/reline/commit/a93119c847

[ruby/irb] Version 1.2.2

https://github.com/ruby/irb/commit/a71753f15a

[ruby/reline] Version 0.1.3

https://github.com/ruby/reline/commit/ea2b182466

[ruby/irb] Include easter-egg.rb in gemspec

irb doesn't run because this file isn't included in the gem.

https://github.com/ruby/irb/commit/73cda56d25

[ruby/irb] Version 1.2.3

https://github.com/ruby/irb/commit/dd56e06df5

support multi-run test for test_readline.rb

[ruby/irb] yield outside method definition is a syntax error

https://github.com/ruby/irb/commit/dbc7b059c7

test/readline - allow ENV control of test class creation

In ruby/ruby, the tests run on both readline & reline by creating four test classes:

TestReadline

TestReadlineHistory

TestRelineAsReadline

TestRelineAsReadlineHistory

 Reline inports the test files and uses them in its CI.  Adding the ENV control allows it to only run the TestRelineAsReadline classes.

Omit test_using_quoting_detection_proc_with_multibyte_input temporarily for random order test

support random order test.
test_readline:

HISTORY should be empty.

test_using_quoting_detection_proc:

test_using_quoting_detection_proc_with_multibyte_input:

Readline.completer_quote_characters= and

Readline.completer_word_break_characters= doesn't accept nil,

so skip if previous values are nil.

Set Readline.completion_append_character = nil always

GNU Readline add a white space when Readline.completion_append_character is

not initialized.

Fix a typo [ci skip]

skip test if Reline.completion_proc is nil.

Some other tests can set Reline.completion_proc, so if it is nil,

simply skip this test.

Reset Reline.point

TestRelineAsReadline#test_insert_text expects Readline.point == 0

at the beginning of the test, but a test violate this assumption.

Convert incompatible encoding symbol names

Ignore incompatible convert of symbols

Add workaround for test-bundler failure

https://github.com/ruby/actions/runs/500526558?check_suite_focus=true#step:16:127

Failures:

  1) Bundler.setup when Bundler is bundled doesn't blow up

     Failure/Error: expect(err).to be_empty

       expected `"fatal: not a git repository (or any of the parent directories): .git\nfatal: not a git repos

itory (o...the parent directories): .git\nfatal: not a git repository (or any of the parent directories): .git

".empty?` to return true, got false

       Commands:

       $ /home/runner/work/actions/actions/snapshot-master/ruby \

         -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-ma

ster/spec/bundler \

         -rsupport/hax -rsupport/artifice/fail \

         /home/runner/work/actions/actions/snapshot-master/libexec/bundle install --retry 0

       Resolving dependencies...

       Using bundler 2.1.4

       Bundle complete! 1 Gemfile dependency, 1 gem now installed.

       Use `bundle info [gemname]` to see where a bundled gem is installed.

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       # $? => 0

       $ /home/runner/work/actions/actions/snapshot-master/ruby \

         -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-ma

ster/spec/bundler \

         -rsupport/hax -rsupport/artifice/fail \

         /home/runner/work/actions/actions/snapshot-master/libexec/bundle exec ruby -e \

         require\ \'bundler\'\;\ Bundler.setup

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       # $? => 0

     # ./spec/bundler/runtime/setup_spec.rb:1056:in `block (3 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:111:in `block (3 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:111:in `block (2 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:78:in `block (2 levels) in <top (required)>'

make: *** [yes-test-bundler] Error 1
[ruby/irb] Unnamed groups are not captured when named groups are used

https://github.com/ruby/irb/commit/0a641a69b0

[ruby/reline] Work with wrong $/ value correctly

https://github.com/ruby/reline/commit/962ebf5a1b

[ruby/irb] Detect multiple lines output simplify

The old implementation performance test code:

require 'objspace'

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

/\A.*\Z/ !~ ('abc' * 20_000_000)

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

 and run time test.rb:

2.5868 MB

62.226 MB

real    0m1.307s

user    0m0.452s

sys     0m0.797s

 The new implementation performance test code:

require 'objspace'

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

('abc' * 20_000_000).include?("\n")

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

 and run time test.rb:

2.5861 MB

62.226 MB

real    0m0.132s

user    0m0.088s

sys     0m0.042s

 https://github.com/ruby/irb/commit/40d6610baf

[ruby/reline] Suppress error in case INPUTRC env is empty

https://github.com/ruby/reline/commit/bce7e7562b

[ruby/reline] Add yamatanooroti rendering test

https://github.com/ruby/reline/commit/f092519525

[ruby/reline] Rename test suite name of yamatanooroti test

https://github.com/ruby/reline/commit/b0f32f5de4

[ruby/reline] Add a comment why rescue yamatanooroti loading error on the test

https://github.com/ruby/reline/commit/2a8061daec

[ruby/irb] Suppress crashing when EncodingError has occurred without lineno

https://github.com/ruby/irb/commit/13572d8cdc

[ruby/reline] Suppress error when check ambiguous char width in LANG=C

https://github.com/ruby/reline/commit/623dffdd75

[ruby/io-console] Enable only interrupt bits on intr: true

https://github.com/ruby/io-console/commit/baaf929041

[ruby/io-console] bump up to 0.5.4

[ruby/io-console] Update the minimum requirement of Ruby version
https://github.com/ruby/io-console/commit/73e7b6318a

[ruby/io-console] Filter Ruby engine name rather than just /ruby/

This breaks tests using this path on JRuby because the jruby

executable turns into jjruby after the sub.

https://github.com/ruby/io-console/commit/e5951aa34c

[ruby/io-console] bump up to 0.5.5

[ruby/io-console] Prefer keyword arguments

https://github.com/ruby/io-console/commit/5facbfc4c8

[ruby/io-console] [DOC] Improved about intr:

https://github.com/ruby/io-console/commit/82b630cd79

[ruby/io-console] Just ignore the extension on other than CRuby

https://github.com/ruby/io-console/commit/41b6f09574

[ruby/io-console] bump up to 0.5.6
Ruby 2.7 backport about IRB (#2990)

[ruby/reline] Sort completion list

Legacy mode:

$ irb --legacy

irb(main):001:0> l[TAB][TAB]

lambda           load             local_variables  loop

 Before this patch:

$ irb

irb(main):001:0> l[TAB][TAB]

local_variables

loop

lambda

load

 After this patch:

$ irb

irb(main):001:0> l[TAB][TAB]

lambda

load

local_variables

loop

 https://github.com/ruby/reline/commit/6074069c7d
Drop an invalid char as UTF-8

Add test_completion_with_indent_and_completer_quote_characters

This is for 8a705245e55575d4d310a2e956b89a36a5931971.

[ruby/irb] Add tests for RubyLex

The set_auto_indent method calculates the correct number of spaces for

indenting a line. We think there might be a few bugs in this method so

we are testing the current functionality to make sure nothing breaks

when we address those bugs.

Example test failure:

  1) Failure:

TestIRB::TestRubyLex#test_auto_indent [/Users/Ben/Projects/irb/test/irb/test_ruby_lex.rb:75]:

Calculated the wrong number of spaces for:

 def each_top_level_statement

  initialize_input

  catch(:TERM_INPUT) do

    loop do

      begin

        prompt

        unless l = lex

          throw :TERM_INPUT if @line == ''

        else

.

<10> expected but was

<12>.

 https://github.com/ruby/irb/commit/752d5597ab

[ruby/reline] Degenerate the terminal size to [$LINES, $COLUMNS] if it is unknown

This is a workaround for https://github.com/ruby/irb/issues/50

https://github.com/ruby/reline/commit/5725677d1a

[ruby/irb] Fix newline depth with multiple braces

This commit fixes the check_newline_depth_difference method to multiple

open braces on one line into account. Before this change we were

subtracting from the depth in check_newline_depth_difference on

every open brace. This is the right thing to do if the opening and

closing brace are on the same line. For example in a method definition we

have an opening and closing parentheses we want to add 1 to our depth,

and then remove it.

def foo()

end

 However this isn't the correct behavior when the brace spans multiple

lines. If a brace spans multiple lines we don't want to subtract from

check_newline_depth_difference and we want to treat the braces the same

way as we do end and allow check_corresponding_token_depth to pop the

correct depth.

Example of bad behavior:

def foo()

  [

  ]

puts 'bar'

end

 Example of desired behavior:

def foo()

  [

  ]

  puts 'bar'

end
 https://github.com/ruby/irb/commit/7dc8af01e0

text/readline/test_readline.rb - fix skip on Reline (#2743)

TestRelineAsReadline#test_input_metachar passes on MinGW

Add "require 'openstruct'" what is forgotten

[ruby/irb] Fix lib name of OpenStruct

https://github.com/ruby/irb/commit/1f3a84ab6b

Add load path and require for ruby/ruby

Rescue EOFError

If C-d is pressed before IRB is ready, IRB crashes because EOFError occurs.

Complete indented and quoted string correctly

def foo

''.upca[TAB]

This will be completed to be:

def foo

''.upcase

The indent was gone. This commit fixes the bug.

[ruby/irb] Fix crashing when multiple open braces per line

https://github.com/ruby/irb/issues/55

If we had put multiple open braces on a line the with no closing brace

spaces_of_nest array keeps getting '0' added to it. This means that when

we pop off of this array we are saying that we should be in position zero

for the next line. This is an issue because we don't always want to be

in position 0 after a closing brace.

Example:

[[[

]

]

]

 In the above example the 'spaces_of_nest' array looks like this after

the first line is entered: [0,0,0]. We really want to be indented 4

spaces for the 1st closing brace 2 for the 2nd and 0 for the 3rd. i.e.

we want it to be: [0,2,4].

We also saw this issue with a heredoc inside of an array.

[<<FOO]

hello

FOO

 https://github.com/ruby/irb/commit/80c69c8272

Support history-size in .inputrc correctly

Introduce an abstracted structure about the encoding of Reline

The command prompt on Windows always uses Unicode to take input and print

output but most Reline implementation depends on Encoding.default_external.

This commit introduces an abstracted structure about the encoding of Reline.

Remove an unused setting variable

Use Reline.encoding_system_needs if exists
Add tests for vi_insert and vi_add

Implement vi_insert_at_bol and vi_add_at_eol

[ruby/reline] Implement vi_to_next_char

https://github.com/ruby/reline/commit/066ecb0a21

[ruby/reline] Implement vi_prev_char and vi_to_prev_char

https://github.com/ruby/reline/commit/0ad3ee63fa

[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there

https://github.com/ruby/readline-ext/commit/4d44c12832

Stop using minitest dependent methods

Skip a test that uses assert_ruby_status if it doesn't exist

Use omit instead of skip

Check DONT_RUN_RELINE_TEST envvar

[ruby/irb] Add newline_before_multiline_output

https://github.com/ruby/irb/commit/9eb1801a66

[ruby/irb] Fix compatibility with rails before 5.2

Rails before 5.2 added Array#append as an alias to Array#<< ,

so that it expects only one argument.

However ruby-2.5 added Array#append as an alias to Array#push

which takes any number of arguments.

If irb completion is used in rails c (for example "IO.")

it fails with:

irb/completion.rb:206:in `<<': wrong number of arguments (given 3, expected 1) (ArgumentError)

Using Array#push instead of Array#append fixes compatibility.

https://github.com/ruby/irb/commit/5b7bbf9c34

Reline: Use a more robust detection of MinTTY

The previous detection per get_screen_size fails when stdout is passed

to a pipe. That is the case when running ruby tests in parallel ("-j" switch).

In this case Reline believes that it's running on MinTTY and the tests

are running with ANSI IOGate instead of the Windows adapter on MINGW.

So parallel test results were different to that of a single process.

This commit fixes these differencies.

The code is taken from git sources and translated to ruby.

NtQueryObject() is replaced by GetFileInformationByHandleEx(), because

NtQueryObject() is undocumented and is more difficult to use:

https://github.com/git-for-windows/git/blob/c5a03b1e29c69f3f06c8fabd92493edb73469176/compat/winansi.c#L558

Reline: Fix changed test results due to change to UTF-8 on Windows

In commit f8ea2860b0cac1aec79978e6c44168802958e8af the Reline encoding

for native windows console was changed to hardcoded UTF-8.

This caused failures in reline and readline tests, but they were hidden,

because parallel ruby tests incorrectly used Reline::ANSI as IOGate.

Tests failures were raised in single process mode, but not with -j switch.

This patch corrects encodings on native Windows console.

[ruby/irb] [ruby/irb] Rewrite an expression to detect multiline

https://github.com/ruby/irb/commit/ed5cf375a6

https://github.com/ruby/irb/commit/5b7bbf9c34
[ruby/reline] Implement vi_change_meta

https://github.com/ruby/reline/commit/8538e0e10f

Always refer to Reline::IOGate.encoding

Always use UTF-8 for Reline::GeneralIO on Windows

Use test_mode on Reline::History::Test for encoding

[ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

https://github.com/ruby/reline/commit/788f0df845

[ruby/irb] Add a new easter egg: dancing ruby

https://github.com/ruby/irb/commit/e37dc7e58e

[ruby/irb] Exclude useless files from RDoc

https://github.com/ruby/irb/commit/8f1ab2400c

[ruby/irb] Exclude useless files from RDoc

Fix inaccuracy in encoding tests

These tests assume

Encoding.find('locale') == Encoding.find('external')

and fail if they are distinct.

[ruby/reline] Fix Reline::Windows#scroll_down

I mistook Right and Bottom.

https://github.com/ruby/reline/commit/8be401c5f5

[ruby/reline] Bypass cursor down when a char is rendered at eol on Windows

A newline is automatically inserted if a character is rendered at eol on

Windows command prompt.

https://github.com/ruby/reline/commit/4bfea07e4a

[ruby/reline] Organize special keys escape sequences

https://github.com/ruby/reline/commit/41deb1a3d9

[ruby/readline-ext] Remove unnecessary -I$(top_srcdir) when it's an individual gem

https://github.com/ruby/readline-ext/commit/efaca4a5f4

[ruby/readline-ext] Check TestRelineAsReadline existance

https://github.com/ruby/readline-ext/commit/c0a6303168

[ruby/readline-ext] The ruby/assert.h is adopted by Ruby 2.7 or later

https://github.com/ruby/readline-ext/commit/106c31fc1b

Revert "[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there"

This reverts commit 425b2064d394639101854c83a061a0918b33b857.

This cherry-pick was a mistake.

[ruby/readline-ext] Use require check instead of DONT_RUN_RELINE_TEST env

https://github.com/ruby/readline-ext/commit/1df99d1481

[ruby/readline-ext] Add spec.extensions

https://github.com/ruby/readline-ext/commit/8c33abb13c
[ruby/readline-ext] Use rake/extensiokntask to build

https://github.com/ruby/readline-ext/commit/b0b5f709bd

Fix readline build dependency

[ruby/irb] Add test_complete_symbol

https://github.com/ruby/irb/commit/dbbf086c1f

[ruby/irb] Check doc namespace correctly

IRB::InputCompletor::PerfectMatchedProc crashes when doc not found because a

variable name was incorrect.

https://github.com/ruby/irb/commit/889fd4928f

[ruby/irb] Fix auto indent with closed brace

A closed brace in auto-indent shouldn't affect the next brace in the same line,

but it behaves like below:

p() {

}

It's a bug.

https://github.com/ruby/irb/commit/fbe59e344f

[ruby/irb] Use 0.step instead of (..0).each for Ruby 2.5

https://github.com/ruby/irb/commit/5d628ca40e

Revert "[ruby/irb] Add test_complete_symbol"

This reverts commit 3af3431c2c145134996e66f3d8d9ade8ad81bde0.

[ruby/irb] fix reserved words and completion for them

https://github.com/ruby/irb/commit/6184b227ad

Add test_complete_symbol

The previous version of the test method used a symbol, ":abcdefg" to complete

but longer symbols that can be completed are defined by other test methods of

other libs.

test/irb/test_completion.rb: suppress a warning: unused literal ignored

[ruby/reline] Use IO#write instead of IO#print

IO#print always adds a string of $\ automatically.

https://github.com/ruby/reline/commit/a93119c847

[ruby/irb] Version 1.2.2

https://github.com/ruby/irb/commit/a71753f15a

[ruby/reline] Version 0.1.3

https://github.com/ruby/reline/commit/ea2b182466

[ruby/irb] Include easter-egg.rb in gemspec

irb doesn't run because this file isn't included in the gem.

https://github.com/ruby/irb/commit/73cda56d25

[ruby/irb] Version 1.2.3

https://github.com/ruby/irb/commit/dd56e06df5

support multi-run test for test_readline.rb
[ruby/irb] yield outside method definition is a syntax error

https://github.com/ruby/irb/commit/dbc7b059c7

test/readline - allow ENV control of test class creation

In ruby/ruby, the tests run on both readline & reline by creating four test classes:

TestReadline

TestReadlineHistory

TestRelineAsReadline

TestRelineAsReadlineHistory

 Reline inports the test files and uses them in its CI.  Adding the ENV control allows it to only run the TestRelineAsReadline classes.

Omit test_using_quoting_detection_proc_with_multibyte_input temporarily for random order test

support random order test.

test_readline:

HISTORY should be empty.

test_using_quoting_detection_proc:

test_using_quoting_detection_proc_with_multibyte_input:

Readline.completer_quote_characters= and

Readline.completer_word_break_characters= doesn't accept nil,

so skip if previous values are nil.

Set Readline.completion_append_character = nil always

GNU Readline add a white space when Readline.completion_append_character is

not initialized.

Fix a typo [ci skip]

skip test if Reline.completion_proc is nil.

Some other tests can set Reline.completion_proc, so if it is nil,

simply skip this test.

Reset Reline.point

TestRelineAsReadline#test_insert_text expects Readline.point == 0

at the beginning of the test, but a test violate this assumption.

Convert incompatible encoding symbol names

Ignore incompatible convert of symbols

Add workaround for test-bundler failure

https://github.com/ruby/actions/runs/500526558?check_suite_focus=true#step:16:127

Failures:

  1) Bundler.setup when Bundler is bundled doesn't blow up

     Failure/Error: expect(err).to be_empty

       expected `"fatal: not a git repository (or any of the parent directories): .git\nfatal: not a git repos

itory (o...the parent directories): .git\nfatal: not a git repository (or any of the parent directories): .git

".empty?` to return true, got false

       Commands:

       $ /home/runner/work/actions/actions/snapshot-master/ruby \

         -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-ma

ster/spec/bundler \

         -rsupport/hax -rsupport/artifice/fail \

         /home/runner/work/actions/actions/snapshot-master/libexec/bundle install --retry 0

       Resolving dependencies...

       Using bundler 2.1.4
       Bundle complete! 1 Gemfile dependency, 1 gem now installed.

       Use `bundle info [gemname]` to see where a bundled gem is installed.

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       # $? => 0

       $ /home/runner/work/actions/actions/snapshot-master/ruby \

         -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-ma

ster/spec/bundler \

         -rsupport/hax -rsupport/artifice/fail \

         /home/runner/work/actions/actions/snapshot-master/libexec/bundle exec ruby -e \

         require\ \'bundler\'\;\ Bundler.setup

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       # $? => 0

     # ./spec/bundler/runtime/setup_spec.rb:1056:in `block (3 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:111:in `block (3 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:111:in `block (2 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:78:in `block (2 levels) in <top (required)>'

make: *** [yes-test-bundler] Error 1

[ruby/irb] Unnamed groups are not captured when named groups are used

https://github.com/ruby/irb/commit/0a641a69b0

[ruby/reline] Work with wrong $/ value correctly

https://github.com/ruby/reline/commit/962ebf5a1b

[ruby/irb] Detect multiple lines output simplify

The old implementation performance test code:

require 'objspace'

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

/\A.*\Z/ !~ ('abc' * 20_000_000)

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

 and run time test.rb:

2.5868 MB

62.226 MB

real    0m1.307s

user    0m0.452s

sys     0m0.797s

 The new implementation performance test code:

require 'objspace'

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

('abc' * 20_000_000).include?("\n")

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

 and run time test.rb:

2.5861 MB

62.226 MB

real    0m0.132s

user    0m0.088s

sys     0m0.042s

 https://github.com/ruby/irb/commit/40d6610baf

[ruby/reline] Suppress error in case INPUTRC env is empty

https://github.com/ruby/reline/commit/bce7e7562b

[ruby/reline] Add yamatanooroti rendering test

https://github.com/ruby/reline/commit/f092519525
[ruby/reline] Rename test suite name of yamatanooroti test

https://github.com/ruby/reline/commit/b0f32f5de4

[ruby/reline] Add a comment why rescue yamatanooroti loading error on the test

https://github.com/ruby/reline/commit/2a8061daec

[ruby/irb] Suppress crashing when EncodingError has occurred without lineno

https://github.com/ruby/irb/commit/13572d8cdc

[ruby/reline] Suppress error when check ambiguous char width in LANG=C

https://github.com/ruby/reline/commit/623dffdd75

[ruby/io-console] Enable only interrupt bits on intr: true

https://github.com/ruby/io-console/commit/baaf929041

[ruby/io-console] bump up to 0.5.4

[ruby/io-console] Update the minimum requirement of Ruby version

https://github.com/ruby/io-console/commit/73e7b6318a

[ruby/io-console] Filter Ruby engine name rather than just /ruby/

This breaks tests using this path on JRuby because the jruby

executable turns into jjruby after the sub.

https://github.com/ruby/io-console/commit/e5951aa34c

[ruby/io-console] bump up to 0.5.5

[ruby/io-console] Prefer keyword arguments

https://github.com/ruby/io-console/commit/5facbfc4c8

[ruby/io-console] [DOC] Improved about intr:

https://github.com/ruby/io-console/commit/82b630cd79

[ruby/io-console] Just ignore the extension on other than CRuby

https://github.com/ruby/io-console/commit/41b6f09574

[ruby/io-console] bump up to 0.5.6
Ruby 2.7 backport about IRB (#2990)

[ruby/reline] Sort completion list

Legacy mode:
$ irb --legacy

irb(main):001:0> l[TAB][TAB]

lambda           load             local_variables  loop

 Before this patch:

$ irb

irb(main):001:0> l[TAB][TAB]

local_variables

loop

lambda

load

 After this patch:

$ irb

irb(main):001:0> l[TAB][TAB]

lambda

load

local_variables

loop

 https://github.com/ruby/reline/commit/6074069c7d

Drop an invalid char as UTF-8

Add test_completion_with_indent_and_completer_quote_characters

This is for 8a705245e55575d4d310a2e956b89a36a5931971.

[ruby/irb] Add tests for RubyLex

The set_auto_indent method calculates the correct number of spaces for

indenting a line. We think there might be a few bugs in this method so

we are testing the current functionality to make sure nothing breaks

when we address those bugs.

Example test failure:

  1) Failure:

TestIRB::TestRubyLex#test_auto_indent [/Users/Ben/Projects/irb/test/irb/test_ruby_lex.rb:75]:

Calculated the wrong number of spaces for:

 def each_top_level_statement

  initialize_input

  catch(:TERM_INPUT) do

    loop do

      begin

        prompt

        unless l = lex

          throw :TERM_INPUT if @line == ''

        else

.

<10> expected but was

<12>.

 https://github.com/ruby/irb/commit/752d5597ab

[ruby/reline] Degenerate the terminal size to [$LINES, $COLUMNS] if it is unknown

This is a workaround for https://github.com/ruby/irb/issues/50

https://github.com/ruby/reline/commit/5725677d1a

[ruby/irb] Fix newline depth with multiple braces

This commit fixes the check_newline_depth_difference method to multiple

open braces on one line into account. Before this change we were

subtracting from the depth in check_newline_depth_difference on

every open brace. This is the right thing to do if the opening and

closing brace are on the same line. For example in a method definition we

have an opening and closing parentheses we want to add 1 to our depth,

and then remove it.

def foo()
end

 However this isn't the correct behavior when the brace spans multiple

lines. If a brace spans multiple lines we don't want to subtract from

check_newline_depth_difference and we want to treat the braces the same

way as we do end and allow check_corresponding_token_depth to pop the

correct depth.

Example of bad behavior:

def foo()

  [

  ]

puts 'bar'

end

 Example of desired behavior:

def foo()

  [

  ]

  puts 'bar'

end

 https://github.com/ruby/irb/commit/7dc8af01e0

text/readline/test_readline.rb - fix skip on Reline (#2743)

TestRelineAsReadline#test_input_metachar passes on MinGW

Add "require 'openstruct'" what is forgotten

[ruby/irb] Fix lib name of OpenStruct

https://github.com/ruby/irb/commit/1f3a84ab6b

Add load path and require for ruby/ruby

Rescue EOFError

If C-d is pressed before IRB is ready, IRB crashes because EOFError occurs.

Complete indented and quoted string correctly

def foo

''.upca[TAB]

This will be completed to be:

def foo

''.upcase

The indent was gone. This commit fixes the bug.

[ruby/irb] Fix crashing when multiple open braces per line

https://github.com/ruby/irb/issues/55

If we had put multiple open braces on a line the with no closing brace

spaces_of_nest array keeps getting '0' added to it. This means that when

we pop off of this array we are saying that we should be in position zero

for the next line. This is an issue because we don't always want to be

in position 0 after a closing brace.

Example:

[[[

]

]

]

 In the above example the 'spaces_of_nest' array looks like this after
the first line is entered: [0,0,0]. We really want to be indented 4

spaces for the 1st closing brace 2 for the 2nd and 0 for the 3rd. i.e.

we want it to be: [0,2,4].

We also saw this issue with a heredoc inside of an array.

[<<FOO]

hello

FOO

 https://github.com/ruby/irb/commit/80c69c8272

Support history-size in .inputrc correctly

Introduce an abstracted structure about the encoding of Reline

The command prompt on Windows always uses Unicode to take input and print

output but most Reline implementation depends on Encoding.default_external.

This commit introduces an abstracted structure about the encoding of Reline.

Remove an unused setting variable

Use Reline.encoding_system_needs if exists

Add tests for vi_insert and vi_add

Implement vi_insert_at_bol and vi_add_at_eol

[ruby/reline] Implement vi_to_next_char

https://github.com/ruby/reline/commit/066ecb0a21

[ruby/reline] Implement vi_prev_char and vi_to_prev_char

https://github.com/ruby/reline/commit/0ad3ee63fa

[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there

https://github.com/ruby/readline-ext/commit/4d44c12832

Stop using minitest dependent methods

Skip a test that uses assert_ruby_status if it doesn't exist

Use omit instead of skip

Check DONT_RUN_RELINE_TEST envvar

[ruby/irb] Add newline_before_multiline_output

https://github.com/ruby/irb/commit/9eb1801a66

[ruby/irb] Fix compatibility with rails before 5.2

Rails before 5.2 added Array#append as an alias to Array#<< ,

so that it expects only one argument.

However ruby-2.5 added Array#append as an alias to Array#push

which takes any number of arguments.

If irb completion is used in rails c (for example "IO.")

it fails with:

irb/completion.rb:206:in `<<': wrong number of arguments (given 3, expected 1) (ArgumentError)

Using Array#push instead of Array#append fixes compatibility.

https://github.com/ruby/irb/commit/5b7bbf9c34

Reline: Use a more robust detection of MinTTY

The previous detection per get_screen_size fails when stdout is passed

to a pipe. That is the case when running ruby tests in parallel ("-j" switch).

In this case Reline believes that it's running on MinTTY and the tests
are running with ANSI IOGate instead of the Windows adapter on MINGW.

So parallel test results were different to that of a single process.

This commit fixes these differencies.

The code is taken from git sources and translated to ruby.

NtQueryObject() is replaced by GetFileInformationByHandleEx(), because

NtQueryObject() is undocumented and is more difficult to use:

https://github.com/git-for-windows/git/blob/c5a03b1e29c69f3f06c8fabd92493edb73469176/compat/winansi.c#L558

Reline: Fix changed test results due to change to UTF-8 on Windows

In commit f8ea2860b0cac1aec79978e6c44168802958e8af the Reline encoding

for native windows console was changed to hardcoded UTF-8.

This caused failures in reline and readline tests, but they were hidden,

because parallel ruby tests incorrectly used Reline::ANSI as IOGate.

Tests failures were raised in single process mode, but not with -j switch.

This patch corrects encodings on native Windows console.

[ruby/irb] [ruby/irb] Rewrite an expression to detect multiline

https://github.com/ruby/irb/commit/ed5cf375a6

https://github.com/ruby/irb/commit/5b7bbf9c34

[ruby/reline] Implement vi_change_meta

https://github.com/ruby/reline/commit/8538e0e10f

Always refer to Reline::IOGate.encoding

Always use UTF-8 for Reline::GeneralIO on Windows

Use test_mode on Reline::History::Test for encoding

[ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

https://github.com/ruby/reline/commit/788f0df845

[ruby/irb] Add a new easter egg: dancing ruby

https://github.com/ruby/irb/commit/e37dc7e58e

[ruby/irb] Exclude useless files from RDoc

https://github.com/ruby/irb/commit/8f1ab2400c

[ruby/irb] Exclude useless files from RDoc

Fix inaccuracy in encoding tests

These tests assume

Encoding.find('locale') == Encoding.find('external')

and fail if they are distinct.

[ruby/reline] Fix Reline::Windows#scroll_down

I mistook Right and Bottom.

https://github.com/ruby/reline/commit/8be401c5f5

[ruby/reline] Bypass cursor down when a char is rendered at eol on Windows

A newline is automatically inserted if a character is rendered at eol on

Windows command prompt.

https://github.com/ruby/reline/commit/4bfea07e4a

[ruby/reline] Organize special keys escape sequences

https://github.com/ruby/reline/commit/41deb1a3d9

[ruby/readline-ext] Remove unnecessary -I$(top_srcdir) when it's an individual gem

06/25/2025 22/28

https://github.com/git-for-windows/git/blob/c5a03b1e29c69f3f06c8fabd92493edb73469176/compat/winansi.c#L558
https://github.com/ruby/irb/commit/ed5cf375a6
https://github.com/ruby/irb/commit/5b7bbf9c34
https://github.com/ruby/reline/commit/8538e0e10f
https://github.com/ruby/reline/commit/788f0df845
https://github.com/ruby/irb/commit/e37dc7e58e
https://github.com/ruby/irb/commit/8f1ab2400c
https://github.com/ruby/reline/commit/8be401c5f5
https://github.com/ruby/reline/commit/4bfea07e4a
https://github.com/ruby/reline/commit/41deb1a3d9


https://github.com/ruby/readline-ext/commit/efaca4a5f4

[ruby/readline-ext] Check TestRelineAsReadline existance

https://github.com/ruby/readline-ext/commit/c0a6303168

[ruby/readline-ext] The ruby/assert.h is adopted by Ruby 2.7 or later

https://github.com/ruby/readline-ext/commit/106c31fc1b

Revert "[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there"

This reverts commit 425b2064d394639101854c83a061a0918b33b857.

This cherry-pick was a mistake.

[ruby/readline-ext] Use require check instead of DONT_RUN_RELINE_TEST env

https://github.com/ruby/readline-ext/commit/1df99d1481

[ruby/readline-ext] Add spec.extensions

https://github.com/ruby/readline-ext/commit/8c33abb13c

[ruby/readline-ext] Use rake/extensiokntask to build

https://github.com/ruby/readline-ext/commit/b0b5f709bd

Fix readline build dependency

[ruby/irb] Add test_complete_symbol

https://github.com/ruby/irb/commit/dbbf086c1f

[ruby/irb] Check doc namespace correctly

IRB::InputCompletor::PerfectMatchedProc crashes when doc not found because a

variable name was incorrect.

https://github.com/ruby/irb/commit/889fd4928f

[ruby/irb] Fix auto indent with closed brace

A closed brace in auto-indent shouldn't affect the next brace in the same line,

but it behaves like below:

p() {

}

It's a bug.

https://github.com/ruby/irb/commit/fbe59e344f

[ruby/irb] Use 0.step instead of (..0).each for Ruby 2.5

https://github.com/ruby/irb/commit/5d628ca40e

Revert "[ruby/irb] Add test_complete_symbol"

This reverts commit 3af3431c2c145134996e66f3d8d9ade8ad81bde0.

[ruby/irb] fix reserved words and completion for them

https://github.com/ruby/irb/commit/6184b227ad

Add test_complete_symbol

The previous version of the test method used a symbol, ":abcdefg" to complete

but longer symbols that can be completed are defined by other test methods of

other libs.

test/irb/test_completion.rb: suppress a warning: unused literal ignored

[ruby/reline] Use IO#write instead of IO#print
IO#print always adds a string of $\ automatically.

https://github.com/ruby/reline/commit/a93119c847

[ruby/irb] Version 1.2.2

https://github.com/ruby/irb/commit/a71753f15a

[ruby/reline] Version 0.1.3

https://github.com/ruby/reline/commit/ea2b182466

[ruby/irb] Include easter-egg.rb in gemspec

irb doesn't run because this file isn't included in the gem.

https://github.com/ruby/irb/commit/73cda56d25

[ruby/irb] Version 1.2.3

https://github.com/ruby/irb/commit/dd56e06df5

support multi-run test for test_readline.rb

[ruby/irb] yield outside method definition is a syntax error

https://github.com/ruby/irb/commit/dbc7b059c7

test/readline - allow ENV control of test class creation

In ruby/ruby, the tests run on both readline & reline by creating four test classes:

TestReadline

TestReadlineHistory

TestRelineAsReadline

TestRelineAsReadlineHistory

 Reline inports the test files and uses them in its CI.  Adding the ENV control allows it to only run the TestRelineAsReadline classes.

Omit test_using_quoting_detection_proc_with_multibyte_input temporarily for random order test

support random order test.

test_readline:

HISTORY should be empty.

test_using_quoting_detection_proc:

test_using_quoting_detection_proc_with_multibyte_input:

Readline.completer_quote_characters= and

Readline.completer_word_break_characters= doesn't accept nil,

so skip if previous values are nil.

Set Readline.completion_append_character = nil always

GNU Readline add a white space when Readline.completion_append_character is

not initialized.

Fix a typo [ci skip]

skip test if Reline.completion_proc is nil.

Some other tests can set Reline.completion_proc, so if it is nil,

simply skip this test.

Reset Reline.point

TestRelineAsReadline#test_insert_text expects Readline.point == 0

at the beginning of the test, but a test violate this assumption.

Convert incompatible encoding symbol names
Ignore incompatible convert of symbols

Add workaround for test-bundler failure

https://github.com/ruby/actions/runs/500526558?check_suite_focus=true#step:16:127

Failures:

  1) Bundler.setup when Bundler is bundled doesn't blow up

     Failure/Error: expect(err).to be_empty

       expected `"fatal: not a git repository (or any of the parent directories): .git\nfatal: not a git repos

itory (o...the parent directories): .git\nfatal: not a git repository (or any of the parent directories): .git

".empty?` to return true, got false

       Commands:

       $ /home/runner/work/actions/actions/snapshot-master/ruby \

         -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-ma

ster/spec/bundler \

         -rsupport/hax -rsupport/artifice/fail \

         /home/runner/work/actions/actions/snapshot-master/libexec/bundle install --retry 0

       Resolving dependencies...

       Using bundler 2.1.4

       Bundle complete! 1 Gemfile dependency, 1 gem now installed.

       Use `bundle info [gemname]` to see where a bundled gem is installed.

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       # $? => 0

       $ /home/runner/work/actions/actions/snapshot-master/ruby \

         -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-ma

ster/spec/bundler \

         -rsupport/hax -rsupport/artifice/fail \

         /home/runner/work/actions/actions/snapshot-master/libexec/bundle exec ruby -e \

         require\ \'bundler\'\;\ Bundler.setup

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       fatal: not a git repository (or any of the parent directories): .git

       # $? => 0

     # ./spec/bundler/runtime/setup_spec.rb:1056:in `block (3 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:111:in `block (3 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:111:in `block (2 levels) in <top (required)>'

     # ./spec/bundler/spec_helper.rb:78:in `block (2 levels) in <top (required)>'

make: *** [yes-test-bundler] Error 1

[ruby/irb] Unnamed groups are not captured when named groups are used

https://github.com/ruby/irb/commit/0a641a69b0

[ruby/reline] Work with wrong $/ value correctly

https://github.com/ruby/reline/commit/962ebf5a1b

[ruby/irb] Detect multiple lines output simplify

The old implementation performance test code:

require 'objspace'

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

/\A.*\Z/ !~ ('abc' * 20_000_000)

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

 and run time test.rb:

2.5868 MB

62.226 MB

real    0m1.307s

user    0m0.452s

sys     0m0.797s

 The new implementation performance test code:
require 'objspace'

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

('abc' * 20_000_000).include?("\n")

puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

 and run time test.rb:

2.5861 MB

62.226 MB

real    0m0.132s

user    0m0.088s

sys     0m0.042s

 https://github.com/ruby/irb/commit/40d6610baf

[ruby/reline] Suppress error in case INPUTRC env is empty

https://github.com/ruby/reline/commit/bce7e7562b

[ruby/reline] Add yamatanooroti rendering test

https://github.com/ruby/reline/commit/f092519525

[ruby/reline] Rename test suite name of yamatanooroti test

https://github.com/ruby/reline/commit/b0f32f5de4

[ruby/reline] Add a comment why rescue yamatanooroti loading error on the test

https://github.com/ruby/reline/commit/2a8061daec

[ruby/irb] Suppress crashing when EncodingError has occurred without lineno

https://github.com/ruby/irb/commit/13572d8cdc

[ruby/reline] Suppress error when check ambiguous char width in LANG=C

https://github.com/ruby/reline/commit/623dffdd75

[ruby/io-console] Enable only interrupt bits on intr: true

https://github.com/ruby/io-console/commit/baaf929041

[ruby/io-console] bump up to 0.5.4

[ruby/io-console] Update the minimum requirement of Ruby version

https://github.com/ruby/io-console/commit/73e7b6318a

[ruby/io-console] Filter Ruby engine name rather than just /ruby/

This breaks tests using this path on JRuby because the jruby

executable turns into jjruby after the sub.

https://github.com/ruby/io-console/commit/e5951aa34c

[ruby/io-console] bump up to 0.5.5

[ruby/io-console] Prefer keyword arguments

https://github.com/ruby/io-console/commit/5facbfc4c8

[ruby/io-console] [DOC] Improved about intr:

https://github.com/ruby/io-console/commit/82b630cd79

[ruby/io-console] Just ignore the extension on other than CRuby

https://github.com/ruby/io-console/commit/41b6f09574

[ruby/io-console] bump up to 0.5.6
History

#1 - 01/15/2020 03:23 PM - packerbacker89 (Josh Johnson)

Note: none of this behavior occurs in Ruby 2.6.5. This is related exclusively to 2.7.0.

#2 - 01/16/2020 11:42 AM - aycabta (aycabta .)

What OS and virtual console software (Terminal.app, command prompt, xterm...) are you using?

#3 - 01/17/2020 08:21 PM - packerbacker89 (Josh Johnson)

I've found the issue using RedHat 6.10 and reproduced the behavior in CentOS 6.

I was using GNOME Terminal (v 2.31.3) when I discovered the issue.

I checked, and it is working somewhat correctly in xterm and konsole. That is, it does not crash upon hitting 'Home' or 'End'. The odd characters still

appear upon hitting 'Insert', 'Page Up', and 'Page Down'.

#4 - 01/18/2020 02:04 AM - nobu (Nobuyoshi Nakada)

- Description updated

#5 - 01/21/2020 08:23 AM - mame (Yusuke Endoh)

It works perfectly for me.  I'm using GNOME Terminal (GNOME Terminal 3.34.2 using VTE 0.58.2 +BIDI +GNUTLS) in Ubuntu 19.10.

#6 - 01/22/2020 08:05 PM - jaruga (Jun Aruga)

Hi, packerbacker89.

Here are the centos 6 containers, tag 6 and 6.X.

https://hub.docker.com/_/centos/

If you can reproduce the error on the containers, and you can provide the Dockerfile to reproduce it, it might be helpful.

#7 - 01/23/2020 09:28 AM - aycabta (aycabta .)

@packerbacker89

Could you show a full result of gnome-terminal --version?

@jaruga (Jun Aruga)

I think the CUI access via Docker is sometimes not good. It's not perfect compatibility.

#8 - 01/24/2020 07:58 PM - packerbacker89 (Josh Johnson)

@aycabta (aycabta .)

Here is the gnome-terminal version: GNOME Terminal 2.31.3

@jaruga (Jun Aruga)

I'll try to work on reproducing it via the container when I have some time.

#9 - 01/29/2020 06:12 AM - aycabta (aycabta .)

- Status changed from Open to Closed

Applied in changeset git|5d124a3b68982e779946804b5b9578c403c6bdf2.

[ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

06/25/2025 27/28

mailto:shuujii@gmail.com
mailto:kanobt61@gmail.com
mailto:mame@ruby-lang.org
mailto:MSP-Greg@users.noreply.github.com
mailto:nobu@ruby-lang.org
mailto:mrkn@mrkn.jp
mailto:lars@greiz-reinsdorf.de
mailto:kanis@comcard.de
mailto:XrXr@users.noreply.github.com
mailto:hsbt@ruby-lang.org
mailto:nov@yo.rim.or.jp
mailto:nick@puppet.com
mailto:gamelinks007@gmail.com
mailto:ko1@atdot.net
mailto:zn@mbf.nifty.com
mailto:headius@headius.com
https://hub.docker.com/_/centos/
https://bugs.ruby-lang.org/users/11018
https://bugs.ruby-lang.org/users/11389
https://bugs.ruby-lang.org/users/11018
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/5d124a3b68982e779946804b5b9578c403c6bdf2
https://bugs.ruby-lang.org/issues/16510


https://github.com/ruby/reline/commit/788f0df845

#10 - 01/29/2020 06:15 AM - aycabta (aycabta .)

This bug was based on unsupported key sequences environment. This was a good chance to survey it for me. Thank you.

ref. http://blog.bachi.net/?p=2082

#11 - 06/28/2020 07:07 PM - yvo@yvo.net (Yvo van Beek)

I noticed this issue when I connect to my Ubuntu 20.04 server and I press Home or End in the Rails console. This is a new issue introduced with Ruby

2.7.0.

I was using the macOS terminal and I had the Home key mapped to \033[H and the End key mapped to \033[F. Those key commands seem to crash

the IRB (UndefinedConversionError).

Now that I'm using macOS Catalina with ZSH, I can use \001 for Home and \005 for End. That provides a workaround for this issue.

See https://apple.stackexchange.com/a/271648/192935 for more information on the key mappings.
